!
subroutine LA31(A, B, C, D, E, G, X, Error)
! 'Progon5'  :
!., .     
!. . "-" 1996
real, intent(in):: A(:), B(:), C(:), D(:), E(:), G(:)
real:: X(:)
integer:: Error
real, allocatable:: P(:), Q(:), R(:), S(:), T(:)
real, allocatable:: U(:), V(:), W(:)
real AA, DD, A11, A12, A21, A22, B1, B2, zz
integer i, ii, iii, n
!begin
  n=size(A)
  if (n<5) then
    Error=1; return
  end if
  allocate(P(n+2), Q(n+2), R(n+2), S(n+2), T(n+2))
  allocate(U(n), V(n), W(n))
  P(1)=0.0; Q(1)=0.0; R(1)=0.0; S(1)=1.0; T(1)=0.0
  P(2)=0.0; Q(2)=0.0; R(2)=0.0; S(2)=0.0; T(2)=1.0
  do i=1,n
    ii=i+1; iii=i+2
    DD=D(i)+E(i)*Q(i)
    AA=A(i)+DD*Q(ii)+E(i)*R(i)
    if (1.0+AA==1.0) then
      deallocate(P,Q,R,S,T,U,V,W)
      Error=65; return
    end if
    P(iii)=(G(i)-DD*P(ii)-E(i)*P(i))/AA
    Q(iii)=-(B(i)+DD*R(ii))/AA
    R(iii)=-C(i)/AA
    S(iii)=-(DD*S(ii)+E(i)*S(i))/AA
    T(iii)=-(DD*T(ii)+E(i)*T(i))/AA
  end do
  U(n)=0.0; V(n)=0.0; W(n)=1.0
  U(n-1)=0.0; V(n-1)=1.0; W(n-1)=0.0
  do i=n-2, 1, -1
    ii=i+1; iii=i+2
    U(i)=P(iii)+Q(iii)*U(ii)+R(iii)*U(iii)
    V(i)=S(iii)+Q(iii)*V(ii)+R(iii)*V(iii)
    W(i)=T(iii)+Q(iii)*W(ii)+R(iii)*W(iii)
  end do
  A11=1.0-S(n+1)-R(n+1)*V(1)
  A12=-(T(n+1)+Q(n+1)+R(n+1)*W(1))
  A21=-(S(n+2)+Q(n+2)*V(1)+R(n+2)*V(2))
  A22=1.0-T(n+2)-Q(n+2)*W(1)-R(n+2)*W(2)
  B1=P(n+1)+R(n+1)*U(1)
  B2=P(n+2)+Q(n+2)*U(1)+R(n+2)*U(2)
  DD=A11*A22-A12*A21
  if (1.0+DD==1.0) then
    deallocate(P,Q,R,S,T,U,V,W)
    Error=65; return
  end if
  X(n-1)=(B1*A22-B2*A12)/DD
  X(n)=(-B1*A21+B2*A11)/DD
  do i=1, n-2
    X(i)=U(i)+V(i)*X(n-1)+W(i)*X(n)
  end do
  deallocate(P, Q, R, S, T, U, V, W)
  Error=0; return
end subroutine LA31
